// C Source File
// Created 3/14/2002; 12:44:14 AM

#define USE_TI89              // Produce .89z File

#define OPTIMIZE_ROM_CALLS    // Use ROM Call Optimization

#define SAVE_SCREEN           // Save/Restore LCD Contents
#include <extgraph.h>
#include <tigcclib.h> // Include All Header Files
//#include "turf.h"
typedef union {
	unsigned char a; // the state indicator
	struct{
	unsigned char w:6,m:2;}b; // w = what to write m=where to move
} ARRTYPE;
//sprites
//I hated to use sprites but because of the failure of the character idea this is how it worked out but hey they're only 30 bytes
static unsigned char numarr[17][5]=
{{0x20,0x50,0x50,0x20,0x00},
{0x20,0x60,0x20,0x20,0x70},
{0x20,0x50,0x10,0x20,0x70},
{0x60,0x10,0x20,0x10,0x60},
{0x50,0x50,0x70,0x10,0x10},
{0x70,0x40,0x60,0x10,0x60},
{0x30,0x40,0x70,0x50,0x70},
{0x70,0x10,0x10,0x20,0x20},
{0x20,0x50,0x20,0x50,0x20},
{0x70,0x50,0x70,0x10,0x60},
{0x20,0x50,0x70,0x50,0x50},
{0x60,0x50,0x60,0x50,0x60},
{0x20,0x50,0x40,0x50,0x20},
{0x60,0x50,0x50,0x50,0x60},
{0x70,0x40,0x60,0x40,0x70},
{0x70,0x40,0x60,0x40,0x40},
{0xD8,0x88,0x88,0xD8,0x00},
};
	INT_HANDLER autointone;
	INT_HANDLER autointtwo;//must be global
//funks
void drawspot(unsigned short arrpos,unsigned char val){
	unsigned char x,y,z;//spot tellers, z is speed temp
	x=(arrpos%32)*5;//use modulo for x
	y=arrpos/32*6;//use division for y
	z=val%4;//the curent color
  DrawGrayRect(x,y,x+4,y+5,1+7*(z==1)+(z==2)+3*(z==3),1);
	z=val/4;//the symbol
	GraySprite8_XOR(x,y+1,5,numarr[z],numarr[z],GetPlane(0),GetPlane(1));
	return;
}

void drawcurser(unsigned short arrpos){
	unsigned char x,y;
	x=(arrpos%32)*5;
	y=arrpos/32*6;
	InvertGrayRect(x,y,x+1,y+1);
	InvertGrayRect(x+3,y,x+4,y+1);
	InvertGrayRect(x,y+4,x+1,y+5);
	InvertGrayRect(x+3,y+4,x+4,y+5);//draw the four squares
	return;
}
void binfo(unsigned short arrpos,unsigned short stloc,char *scrarray){
	SetPlane(0);
	printf_xy(38,91,"%03u",arrpos);
	printf_xy(94,91,"%03u",stloc);
	printf_xy(144,91,"%02u",scrarray[arrpos]);
	SetPlane(1);
	printf_xy(38,91,"%03u",arrpos);
	printf_xy(94,91,"%03u",stloc);
	printf_xy(144,91,"%02u",scrarray[arrpos]);
	return;
}
void stpo(unsigned short arrpos){
	GraySprite8_XOR((arrpos%32)*5,arrpos/32*6+1,5,numarr[16],numarr[16],GetPlane(0),GetPlane(1));
}
void msgmaker(unsigned char a,unsigned long itnum){
	unsigned char titletwo[]="results",msgs[2][24]={"the machine terminated","the machine escaped"},buff[25];
	GrayOff();//
	SetIntVec (AUTO_INT_1,autointone);//
	SetIntVec (AUTO_INT_2,autointtwo);//return the lines for the mesage boxes
	sprintf (buff,"after %lu iterations",itnum);
	DlgMessage(titletwo,buff,BT_NONE,BT_NONE);
	DlgMessage(titletwo,msgs[a],BT_NONE,BT_NONE);
	SetIntVec(AUTO_INT_1,DUMMY_HANDLER); //remove pesky line at the bottom 
	SetIntVec(AUTO_INT_2,DUMMY_HANDLER); 
	FontSetSys(0); 
	GrayOn();
	SetPlane (0);
	ClrScr();
	SetPlane (1);
	ClrScr();//reready the screen
}
// Main Function
void _main(void)
{
ESI argpoi=top_estack; //to get matrix
char errone[]="invalid input",titleone[]="problem",errtwo[]="invalid data",errthree[]="insufficient memory"; //error msgs
unsigned short qa=0,ws=0,ed=0,rf=0,tg=0,yh=0,delaynum=0;//auxillary vars(for for loops and such)
unsigned long itnum=0;
	if(!is_matrix(argpoi)){DlgMessage(titleone,errone,BT_NONE,BT_NONE);return;}//matrix?
	if(remaining_element_count(argpoi-2)!=3){DlgMessage(titleone,errone,BT_NONE,BT_NONE);return;}//are there 3 columbs(or however you spell it)
	argpoi-=2;// set it to the first data
		if(GetArgType(argpoi)!=POSINT_TAG){DlgMessage(titleone,errtwo,BT_NONE,BT_NONE);return;}//check to see if it is the right type
			if(((tg=GetIntArg(argpoi))>64)||(tg<2)){DlgMessage(titleone,errtwo,BT_NONE,BT_NONE);return;}//make sure number of symbols is in a usable range
			if(GetArgType(argpoi)!=POSINT_TAG){DlgMessage(titleone,errtwo,BT_NONE,BT_NONE);return;}//check to see if it is the right type
			yh=GetIntArg(argpoi);//take initial state
		if(GetArgType(argpoi)!=POSINT_TAG){DlgMessage(titleone,errtwo,BT_NONE,BT_NONE);return;}//check to see if it is the right type
			delaynum=GetIntArg(argpoi);//take the dalay amount
	argpoi--;//set it back onto the lists
ARRTYPE popparray[(qa=remaining_element_count(argpoi))][tg*2]; //initialize the --mighty-- poppa array and tell qa how many rows there are
	if((qa % tg!=0)||(qa>tg*256)||(yh>qa/tg-1)){DlgMessage(titleone,errone,BT_NONE,BT_NONE);return;}// must be have a return for each symbol on each state and have more than  256 states and check if the initial state is outside range
	argpoi--;//set it to the first data list
	for(ws=0;ws<qa/tg;ws++){ // fill the array 
			for(rf=0;rf<tg;rf++){
				if(GetArgType(argpoi)!=POSINT_TAG){DlgMessage(titleone,errtwo,BT_NONE,BT_NONE);return;}//check to see if it is the right type
			if((ed=GetIntArg(argpoi))>=tg){DlgMessage(titleone,errtwo,BT_NONE,BT_NONE);return;}//take the value and make sure it is bit sized 
			//(popparray[ws][1]).w for futer copying
			(popparray[ws][rf*2]).b.w=ed;//put in var
				if(GetArgType(argpoi)!=POSINT_TAG){DlgMessage(titleone,errtwo,BT_NONE,BT_NONE);return;}//check to see if it is the right type
			if((ed=GetIntArg(argpoi))>3){DlgMessage(titleone,errtwo,BT_NONE,BT_NONE);return;}// take another value and check
			(popparray[ws][rf*2]).b.m=ed;//put in var
				if(GetArgType(argpoi)!=POSINT_TAG){DlgMessage(titleone,errtwo,BT_NONE,BT_NONE);return;}//check to see if it is the right type
			if((ed=GetIntArg(argpoi))>qa/tg-1){DlgMessage(titleone,errtwo,BT_NONE,BT_NONE);return;}//take yet another and make sure it is byte sized *literaly*
			(popparray[ws][rf*2+1]).a=ed;// put in var
			argpoi-=2;//skip the END_TAG and LIST_TAG thats after the data and go to the next list
		}
	}// done initializing!
	rf=qa/tg-1;//max state number
	//tg = number of symbols
	//yh = initial state
	autointone=GetIntVec(AUTO_INT_1);
	SetIntVec(AUTO_INT_1,DUMMY_HANDLER); //remove pesky line at the bottom 
	autointtwo=GetIntVec(AUTO_INT_2);
	SetIntVec(AUTO_INT_2,DUMMY_HANDLER); 
	FontSetSys(0); //make small font
	GrayOn();//duh
	//SetPlane (0); // to copy
	SetPlane (0);
	ClrScr();
	SetPlane (1);
	ClrScr();//ready the screen
	unsigned char *scrarray;
	if((scrarray=calloc(480,1))==H_NULL){DlgMessage(titleone,errthree,BT_NONE,BT_NONE);return;}//set up a screen array
		ws=0;//the starting start location
		retag:
		qa=0;//the current block
		//_rowread(~((short)(1<<2))) & (1<<3)  to copy rowreads
		for(ed=0;ed<480;ed++)drawspot(ed,scrarray[ed]);//draw the first screen
		drawcurser(qa);//draw the first curser
		stpo(ws);//draw the start position
		SetPlane(0);
		printf_xy (5,91,"cur pos - %03u",qa);
		printf_xy (56,91,"start pos - %03u",ws);
		printf_xy (111,91,"cur val - %02u",scrarray[qa]);
		SetPlane(1);
		printf_xy (5,91,"cur pos - %03u",qa);
		printf_xy (56,91,"start pos - %03u",ws);
		printf_xy (111,91,"cur val - %02u",scrarray[qa]);//set up info + the text
		while(!(_rowread(~((short)(1<<5))) & (1<<7))){//setup loop until the f1 initiator
			if(_rowread(~((short)(1<<1))) & (1<<7))goto exit;//f5 to escape
			
			if((ed=_rowread(~((short)(1<<0))) & (15))){
				drawcurser(qa);//erase the old curser (because of inverse/inverse)
				if(ed & (1<<0)){
					if(qa>31)qa-=32;//check and shift up
				}
				if(ed & (1<<2)){
					if(qa<448)qa+=32;//check and shift down
				}
				if(ed & (1<<1)){
					if(qa>0)qa--;//check and shift left
				}
				if(ed & (1<<3)){
					if(qa<479)qa++;//check and shift right
				}
				drawcurser(qa);//draw the new curser
				binfo(qa,ws,scrarray);//along with its info
				for(ed=0;ed<50;ed++) rand()/rand()/rand();
			}
			if(_rowread(~((short)(1<<1))) & (1<<6)){
				for(ed=0;ed<500;ed++) rand()/rand()/rand();//to slow it down
			}
			if(_rowread(~((short)(1<<2))) & (1<<6)){
				for(ed=0;ed<1000;ed++) rand()/rand()/rand();//to slow it down
			}
			if(_rowread(~((short)(1))) & (1<<7)){
				for(ed=0;ed<800;ed++) rand()/rand()/rand();//to slow it down
			}
			if(_rowread(~((short)(1))) & (1<<5)){
				stpo(ws);//erase the start pos
				ws=qa;//change the pos
				stpo(ws);//draw the pos
				binfo(qa,ws,scrarray);//and its info
			}
			if(_rowread(~((short)(1))) & (1<<4)){
				if(scrarray[qa]<(tg-1))(scrarray[qa])++;//make sure it fits
				drawspot(qa,scrarray[qa]);//draw the new symbol
				drawcurser(qa);//redraw the curser
				if(ws==qa)stpo(ws);//redraw the start if it was drawn over
				binfo(qa,ws,scrarray);//and update its info
			}//greaten the current value
			if(_rowread(~((short)(1))) & (1<<6)){
				if(scrarray[qa]>0)(scrarray[qa])--;//make sure it fits
				drawspot(qa,scrarray[qa]);//draw the new symbol
				drawcurser(qa);//redraw the curser
				if(ws==qa)stpo(ws);//redraw the start if it was drawn over
				binfo(qa,ws,scrarray);//and update
			}//lessen the curent value	
		}
		drawcurser(qa);//erase the curser but keep the start position
		//ws will now be the curent pos
		//and qa will be the cur state
		DrawGrayRect(0,90,159,99,1,1);//delete the text
		qa=yh;
		itnum=0;//reset counter
		SetPlane(0);
		printf_xy (5,91,"cur pos - %03u",ws);
		printf_xy (55,91,"cur state - %03u",qa);
		printf_xy (111,91,"cur val - %02u",scrarray[ws]);
		SetPlane(1);
		printf_xy (5,91,"cur pos - %03u",ws);
		printf_xy (55,91,"cur state - %03u",qa);
		printf_xy (111,91,"cur val - %02u",scrarray[ws]);
		while(!(_rowread(~((short)(1<<1))) & (1<<7))){//set the exit for the master turing loop
			if(_rowread(~((short)(1<<4))) & (1<<7))goto retag;
				ed=qa;//use ed to not forget qa
				rf=ws;//or its position
					qa=(popparray[ed][scrarray[rf]*2+1]).a;//change the state
			//if(((ws==0)&&((popparray[ed][scrarray[rf*2]]).m==0))||((ws==479)&&((popparray[ed][scrarray[rf*2]]).m==2)))
					ws=ws+(popparray[ed][scrarray[rf]*2]).b.m-1;//move the curser
					if((popparray[ed][scrarray[rf]*2]).b.m==3){ws=rf;scrarray[rf]=(popparray[ed][scrarray[rf]*2]).b.w;drawspot(rf,scrarray[rf]);msgmaker(0,itnum);goto retag;}
					scrarray[rf]=(popparray[ed][scrarray[rf]*2]).b.w;//change the symbol
					if((ws==(unsigned short)(-1))||(ws==480)){ws=rf;drawspot(rf,scrarray[rf]);msgmaker(1,itnum);goto retag;}//check for escape
					stpo(rf);
					drawspot(rf,scrarray[rf]);//draw its new state (put here in case the spot didn't move) 
					stpo(ws);//erase the old position and draw the new
					binfo(ws,qa,scrarray);//and update the info
				itnum++;
				for(ed=0;ed<delaynum;ed++)rand()/rand()/rand();
		}
	goto exit;
exit:
GrayOff();//almost forgot
free(scrarray);//important
SetIntVec (AUTO_INT_1,autointone);//return pesky line
SetIntVec (AUTO_INT_2,autointtwo);
ngetchx();
ngetchx();
}

/*
usefull stuff from the docs
There is a lot of methods. I suggest the following one: 
ESI ptr;
int result;
int i = 1;                             // Just an example
int j = 2;
push_parse_text ("[[11,12][21,22]]");  // An example matrix
ptr = locate_element (i,j);
result = GetIntArg (ptr);              // (assumed that elements are ints)

where 'locate_element' is an user-written function, which may be implemented as follows: 
ESI locate_element (short m, short n)
{
  short i;
  ESI ptr = top_estack-1;
  for (i = 0; i < m-1; i++) ptr = next_expression_index (ptr);
  ptr--;
  for (i = 0; i < n-1; i++) ptr = next_expression_index (ptr);
  return ptr;
}
*/